<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Dozent\Urlaube\NeuAbsenden;

use Kufer\Web\KuferTools\Dozent\Urlaube\Neu\UrlaubNeuController;
use Kufer\Web\KuferTools\Dozent\Urlaube\Neu\Urlaubsplanung;

class UrlaubNeuAbsendenController extends \Kufer\KuferTools\Basis\Controller\Controller
{
  protected function getUseCase(): \Kufer\KuferTools\Basis\UseCase\UseCase
  {
    return new UrlaubNeuAbsendenUseCase($this->getRequestObj());
  }

  protected function getRequestObj()
  {
    $result = new UrlaubNeuAbsendenRequest();
    $result->urlaubsplanung = new Urlaubsplanung();
    $result->urlaubsplanung->fromRequest('urlaubsplanung');

    return $this->handleXsrf($result, $this->getActionVal());
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return new UrlaubNeuAbsendenPresenter($pUseCaseResponse);
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    if (!$pUseCaseResponse->success) {
      return new UrlaubNeuController($pUseCaseResponse->urlaubsplanung);
    }

    return null;
  }
}